// scripted by Rassadin Pavel (RPV); e-mail: mf36@yandex.ru; data: 19.06.2006; freeware;

const mm = 72/25.4;
var doc = app.activeDocument;

var dialogStr = "l/r/c; t/d/c; rotate; docName/layername(0/1); sizeText";

//default parameters
var defStr = "l t 0 0 12"; 

var XposNameLayer = 0;
var YposNameLayer = 0;
var	dx = 0;
var	dy = 0;

var RegClr = new SpotColor();
	RegClr.spot = doc.spots['[Registration]'];

doc.rulerOrigin = Array(0, 0);	
origin = doc.rulerOrigin;

if (documents.length > 0){
	if (of = prompt(dialogStr, defStr,"MarkLayers")){
		param = of.split(' ');
		xOf = param[0].split('+');
		if (xOf.length>1) dx = xOf[1]*mm;
		else {
			xOf = param[0].split('-');
			if (xOf.length>1) dx = - xOf[1]*mm;
			else dx = 0;
		}		
		yOf = param[1].split('+');
		if (yOf.length>1) dy = yOf[1]*mm;
		else {
			yOf = param[1].split('-');
			if (yOf.length>1) dy = - yOf[1]*mm;
			else dy = 0;
		}			
		rotateAngle = param[2];
		nameStr = param[3];
		sizeText = param[4];		
		fullDocName = doc.fullName;	
		fold = doc.name.split('.');				
		targetFile="";
		if (fold.length>1) {
			for (i=0; i<fold.length-1; i++){
				targetFile = targetFile + fold[i];
			}
			realDocName = targetFile;
		}
		else realDocName = fold[0];					
		for (i=0; i<doc.layers.length; i++)
			if (doc.layers[i].locked == false) doc.layers[i].visible = false;		
		if (doc.layers[0].locked == false) {
			doc.layers[0].visible = true;
			if (nameStr == "1") Name = realDocName+'_'+doc.layers[0].name;
			else Name = doc.layers[0].name;
			MarkLayer (Name,0);
			sum = 0;
		}		
		for (i=1; i<doc.layers.length; i++){
			if (doc.layers[i-1].locked == false) doc.layers[i-1].visible = false;
			if (doc.layers[i].locked == false) {
				doc.layers[i].visible = true;
				if (nameStr == "1") Name = realDocName+'_'+doc.layers[i].name;
				else Name = doc.layers[i].name;
				MarkLayer (Name,i);
				sum = i;
			}			
		}
		doc.layers[sum].visible = true;
	}	
}

function MarkLayer (Name,i){	
	for (j=0; j<doc.layers[i].layers.length; j++){
		param = doc.layers[i].layers[j].name.split(' ');			
		for (k=0; k<param.length; k++)
			if (param[k] == 'markLayers'){
				if (doc.layers[i].layers[j].locked == true) doc.layers[i].layers[j].locked = false; 
				doc.layers[i].layers[j].remove();
				j-=1;
			}
	}
	var mLayer= doc.layers[i].layers.add();    	 
		mLayer.name = 'markLayers';
	var textStr = doc.activeLayer.textFrames.add();	
	textStr.contents = Name;
	textStr.textRange.characterAttributes.size = sizeText;
	textStr.textRange.characterAttributes.fillColor = RegClr;
	textStr.rotate (rotateAngle);		
	switch(xOf[0]){				
		case "l": XposNameLayer = 0+dx;				
		break;
		case "r": XposNameLayer = doc.width - textStr.width+dx;				
		break;
		case "c": XposNameLayer = (doc.width - textStr.width)/2+dx;				
		break;
	}	
	switch(yOf[0]){				
		case "d": YposNameLayer = textStr.height + dy;				
		break;
		case "t": YposNameLayer = doc.height + dy;				
		break;
		case "c": YposNameLayer = (doc.height + textStr.height)/2 + dy;				
		break;
	}				
	textStr.top = YposNameLayer;
	textStr.left = XposNameLayer;
}

